#Jonas Helfer, 14.12.2012 for MIT Computer Systems Security 6.858 final Project
#Remove permissions from Android apps
#removes permission from AndroidManifest.xml and replaces API calls that require the removed permissions with calls to a static "dummy" function that always returns a valid default value


import sys, os
import subprocess
import shutil

def runcmd(command,print_output = True):
    print " ######### " + command + "###########"
    instr = command.split(" ") 
    print instr
    output,err = subprocess.Popen(instr,stdout=subprocess.PIPE).communicate()
    #print "err is:---------------------------------"
    #print err
    if(print_output):
        print "output is:----------------------------------"
        print output
    print "####################################"
    return output

def revert(appname):
    return runcmd("./revert.sh " + appname)

def buildandsign(appname):
    return runcmd("./buildandsign.sh " + appname)

def remove_permissions(appname,perms):
    runcmd("./removepermission.sh " + appname + " " + " ".join(perms))

    require_fakemanager = False
    for perm in perms:
        original_calls = runcmd("./findapicalls.sh " + appname + " " + perm,False)
        original_count = len([x for x in original_calls.split("\n") if len(x) and not x.startswith("#")])        



        if original_count > 0:
            require_fakemanager = True
            scriptname = "appsafe/"+perm+".sh"
            if not os.path.exists(scriptname):
                print "removal not implemented: " + perm
                continue
            
            runcmd(scriptname + " " + appname+ "/smali/")
            calls = runcmd("./findapicalls.sh " + appname + " " + perm,False)
            remaining_count = 0
            for line in calls.split("\n"):
                if len(line) and not line.startswith("#"):
                    remaining_count += 1
                    print str(remaining_count) + "> " + line

            print "Replaced " + str(original_count - remaining_count) + " of " + str(original_count) + " protected API calls"
            if remaining_count != 0:
                print "ATTENTION: There are still " + str(remaining_count) + " protected API calls that have not been replaced"

    if require_fakemanager:
        print "copying StaticFakeEverythingManager"
        directory = appname + "/smali/com/securityl/mylocationapp/"
        if not os.path.exists(directory):
            os.makedirs(directory)
        
        SFEM = "StaticFakeEverythingManager.smali"
        shutil.copyfile("./appsafe/"+SFEM,directory+SFEM)


if __name__ == "__main__":
    assert len(sys.argv) >= 2
    appname = sys.argv[1]
    revert(appname)
    if len(sys.argv) > 2:
        perms = sys.argv[2:]
        remove_permissions(appname,perms)

    buildandsign(appname)

    print "DONE!"
